#include "class_iscrizione.h"
#include <iostream>
#include <cstring>
using namespace std;

void Iscrizione::init() {
   testa = nullptr;
}

void Iscrizione::visualizza() {
   cout << "Atleti iscritti:" << endl;
   for(elem*q = testa; q != nullptr; q = q->pun)
      cout << q->nome << ", " << q->pettorale << endl;
   cout << endl;
}

bool Iscrizione::aggiungi(const char* nome, int pettorale) {
   //valido l'input
   if(strlen(nome) > 30) {
      return false;
   }

   elem* q, *p, *r;
   //controllo se nome  gia' inserito nella lista
   for(q = testa; q != nullptr; q = q->pun) {
      if ((strcmp(q->nome, nome) == 0) || (q->pettorale == pettorale))
         return false;
   }

   //inserisco nome in fondo
   for(q = testa; q != nullptr; q = q->pun) 
      p = q;

   r = new elem;
   strcpy(r->nome, nome);
   r->pettorale = pettorale;
   r->pun = nullptr;

   if(q == testa)
      testa = r;
   else 
      p->pun = r;

   return true;
}

bool Iscrizione::cerca(const char* nome) {
   for(elem*q = testa; q != nullptr; q = q->pun) {
      if(strcmp(q->nome, nome) == 0)
         return true;
   }
   return false;
}

bool Iscrizione::elimina(const char* nome) {
   elem* p, *q;
   // scorro finche' non trovo l'atleta con quel nome o finche' non finisce la lista
   for(q = testa; (q!= nullptr) && (strcmp(q->nome, nome) != 0); q = q->pun)
      p = q;

   if (q == nullptr)
      return false;

   if(q == testa) // eliminazione in testa
      testa = q->pun;
   else  
      p->pun = q->pun;

   delete q;
   return true;
}
